Index: main/ikobacustom.pcn/trunk/src/ikobacustom/pcn/customers/batching.py
===================================================================
--- main/ikobacustom.pcn/trunk/src/ikobacustom/pcn/customers/batching.py	(revision 12615)
+++ main/ikobacustom.pcn/trunk/src/ikobacustom/pcn/customers/batching.py	(revision 12616)
@@ -70,5 +70,5 @@
     util_name = 'roncontractprocessor'
     grok.name(util_name)
-    name = _('Retention of Name Contract Processor')
+    name = _('License Processor: Retention of Name')
     iface = IRONContract
     factory_name = 'waeup.RONContract'
@@ -79,5 +79,5 @@
     util_name = 'ropcontractprocessor'
     grok.name(util_name)
-    name = _('Registration of Premises Contract Processor')
+    name = _('License Processor: Registration of Premises')
     iface = IROPContract
     factory_name = 'waeup.ROPContract'
@@ -88,5 +88,5 @@
     util_name = 'rprcontractprocessor'
     grok.name(util_name)
-    name = _('Registration in the Provisional Register Contract Processor')
+    name = _('License Processor: Registration in the Provisional Register')
     iface = IRPRContract
     factory_name = 'waeup.RPRContract'
@@ -97,5 +97,5 @@
     util_name = 'rpccontractprocessor'
     grok.name(util_name)
-    name = _('Registration as Pharmaceutical Chemist Contract Processor')
+    name = _('License Processor: Registration as Pharmaceutical Chemist')
     iface = IRPCContract
     factory_name = 'waeup.RPCContract'
@@ -106,5 +106,5 @@
     util_name = 'ippmvlcontractprocessor'
     grok.name(util_name)
-    name = _('Issuance of Patent and Proprietary Medicines Vendors License (Contract) Processor')
+    name = _('License Processor: Issuance of Patent and Proprietary Medicines Vendors License')
     iface = IIPPMVLContract
     factory_name = 'waeup.IPPMVLContract'
@@ -115,5 +115,5 @@
     util_name = 'rppmvlcontractprocessor'
     grok.name(util_name)
-    name = _('Renewal of Patent and Proprietary Medicines Vendors License (Contract) Processor')
+    name = _('License Processor: Renewal of Patent and Proprietary Medicines Vendors License')
     iface = IRPPMVLContract
     factory_name = 'waeup.RPPMVLContract'
@@ -124,5 +124,5 @@
     util_name = 'appitcontractprocessor'
     grok.name(util_name)
-    name = _('Accepting Pupil Pharmacist for Internship Training (Contract) Processor')
+    name = _('License Processor: Accepting Pupil Pharmacist for Internship Training')
     iface = IAPPITContract
     factory_name = 'waeup.APPITContract'
@@ -133,5 +133,5 @@
     util_name = 'rptcontractprocessor'
     grok.name(util_name)
-    name = _('Registration as a Pharmacy Technician (Contract) Processor')
+    name = _('License Processor: Registration as a Pharmacy Technician')
     iface = IRPTContract
     factory_name = 'waeup.RPTContract'
Index: main/ikobacustom.pcn/trunk/src/ikobacustom/pcn/customers/export.py
===================================================================
--- main/ikobacustom.pcn/trunk/src/ikobacustom/pcn/customers/export.py	(revision 12615)
+++ main/ikobacustom.pcn/trunk/src/ikobacustom/pcn/customers/export.py	(revision 12616)
@@ -63,5 +63,5 @@
     grok.name('roncontracts')
     iface = IRONContractProcess
-    title = _(u'Retention of Name Contracts')
+    title = _(u'Licenses: Retention of Name')
     class_name = 'RONContract'
 
@@ -72,5 +72,5 @@
     grok.name('ropcontracts')
     iface = IROPContractProcess
-    title = _(u'Registration of Premises Contracts')
+    title = _(u'Licenses: Registration of Premises')
     class_name = 'ROPContract'
 
@@ -80,5 +80,5 @@
     grok.name('rprcontracts')
     iface = IRPRContractProcess
-    title = _(u'Registration in the Provisional Register Contracts')
+    title = _(u'Licenses: Registration in the Provisional Register')
     class_name = 'RPRContract'
 
@@ -88,5 +88,5 @@
     grok.name('rpccontracts')
     iface = IRPCContractProcess
-    title = _(u'Registration as Pharmaceutical Chemist Contracts')
+    title = _(u'Licenses: Registration as Pharmaceutical Chemist')
     class_name = 'RPCContract'
 
@@ -96,5 +96,5 @@
     grok.name('ippmvlcontracts')
     iface = IIPPMVLContractProcess
-    title = _(u'Issuance of Patent and Proprietary Medicines Vendors Licenses')
+    title = _(u'Licenses: Issuance of Patent and Proprietary Medicines Vendors')
     class_name = 'IPPMVLContract'
 
@@ -104,5 +104,5 @@
     grok.name('rppmvlcontracts')
     iface = IRPPMVLContractProcess
-    title = _(u'Renewal of Patent and Proprietary Medicines Vendors Licenses')
+    title = _(u'Licenses: Renewal of Patent and Proprietary Medicines Vendors')
     class_name = 'RPPMVLContract'
 
@@ -112,5 +112,5 @@
     grok.name('appitcontracts')
     iface = IAPPITContractProcess
-    title = _(u'Accepting Pupil Pharmacist for Internship Training Contracts')
+    title = _(u'Licenses: Accepting Pupil Pharmacist for Internship Training')
     class_name = 'APPITContract'
 
@@ -120,4 +120,4 @@
     grok.name('rptcontracts')
     iface = IRPTContractProcess
-    title = _(u'Registration as a Pharmacy Technician Contracts')
+    title = _(u'Licenses: Registration as a Pharmacy Technician')
     class_name = 'RPTContract'