Index: /main/waeup.odoo/trunk/README.txt
===================================================================
--- /main/waeup.odoo/trunk/README.txt	(revision 12624)
+++ /main/waeup.odoo/trunk/README.txt	(revision 12624)
@@ -0,0 +1,111 @@
+waeup.openerp
+*************
+
+Install
+=======
+
+Please note, that **only Linux-based installs** are described and actively
+supported. We recommend use of Debian / Ubuntu.
+
+
+Preparing the System
+--------------------
+
+Necessary packages can be installed on Debian systems like this::
+
+  $ sudo apt-get install postgresql
+
+Occasionally, PostgreSQL 9.1 database server cannot be started.
+In order to resolve the error, you need to edit the postgresql.conf file
+(located in my /etc/postgresql/9.1/main directory).
+By default, the ssl is set to true and that is the reason which causes
+the “meaningful” error. You need to set it to false.
+[Source: http://www.jusuchyne.com/codingchyne/2010/04/postgres-could-not-load-private-key-file/]
+
+Restart postgresql and continue with package installation::
+
+  $ sudo apt-get install postgresql-server-dev-9.1 \
+                         python2.7 python2.7-dev build-essential \
+                         libldap2-dev libsasl2-dev libjpeg-dev \
+                         libxslt1-dev libxml2-dev \
+                         python-virtualenv
+
+
+Configuring OpenERP User on Postgres
+------------------------------------
+
+Create a new database user. This is so OpenERP has access rights to connect
+to PostgreSQL and to create and drop databases. Remember what your choice
+of password is here; you will need it later on::
+
+  $ sudo su - postgres
+  $ createuser --createdb --username postgres --no-createrole --no-superuser --pwprompt openerp
+  $ exit
+
+
+Preparing OpenERP System User and Home Folder
+---------------------------------------------
+
+  $ sudo adduser --system --group --shell /bin/bash --home /openerp openerp
+
+Login as OpenERP user::
+
+  $ sudo bash
+  $ su openerp
+  $ cd ~
+
+
+Predefining the ``eggs`` folder
+-------------------------------
+
+Create ``~/.buildout/default.cfg`` with the
+following contents::
+
+  [buildout]
+  eggs-directory = /openerp/eggs
+
+
+Bootstrapping the Buildout
+--------------------------
+
+Install local sandbox::
+
+  $ virtualenv --no-site-packages py27
+
+Activate local sandbox::
+
+  $ source py27/bin/activate
+
+Uninstall local setuptools and pip::
+
+  (py27)$ pip uninstall setuptools pip
+
+Checkout ``waeup.openerp``::
+
+  (py27)$ svn co https://svn.waeup.org/repos/main/waeup.openerp/trunk myopenerp
+
+Finally, perform the bootstrap with the virtualenv's Python::
+
+  (py27)$ cd myopenerp
+  (py27)$ python bootstrap.py
+
+
+Running the Build
+-----------------
+
+Just run::
+
+  $ bin/buildout
+
+Starting OpenERP
+----------------
+
+Run
+
+  $ bin/start_openerp
+
+to start in foreground or
+
+  & nohup bin/start_openerp &
+
+to start in background.
Index: /main/waeup.odoo/trunk/bootstrap.py
===================================================================
--- /main/waeup.odoo/trunk/bootstrap.py	(revision 12624)
+++ /main/waeup.odoo/trunk/bootstrap.py	(revision 12624)
@@ -0,0 +1,179 @@
+##############################################################################
+#
+# Copyright (c) 2006 Zope Foundation and Contributors.
+# All Rights Reserved.
+#
+# This software is subject to the provisions of the Zope Public License,
+# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
+# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
+# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
+# FOR A PARTICULAR PURPOSE.
+#
+##############################################################################
+"""Bootstrap a buildout-based project
+
+Simply run this script in a directory containing a buildout.cfg.
+The script accepts buildout command-line options, so you can
+use the -c option to specify an alternate configuration file.
+"""
+
+import os
+import shutil
+import sys
+import tempfile
+
+from optparse import OptionParser
+
+tmpeggs = tempfile.mkdtemp()
+
+usage = '''\
+[DESIRED PYTHON FOR BUILDOUT] bootstrap.py [options]
+
+Bootstraps a buildout-based project.
+
+Simply run this script in a directory containing a buildout.cfg, using the
+Python that you want bin/buildout to use.
+
+Note that by using --find-links to point to local resources, you can keep 
+this script from going over the network.
+'''
+
+parser = OptionParser(usage=usage)
+parser.add_option("-v", "--version", help="use a specific zc.buildout version")
+
+parser.add_option("-t", "--accept-buildout-test-releases",
+                  dest='accept_buildout_test_releases',
+                  action="store_true", default=False,
+                  help=("Normally, if you do not specify a --version, the "
+                        "bootstrap script and buildout gets the newest "
+                        "*final* versions of zc.buildout and its recipes and "
+                        "extensions for you.  If you use this flag, "
+                        "bootstrap and buildout will get the newest releases "
+                        "even if they are alphas or betas."))
+parser.add_option("-c", "--config-file",
+                  help=("Specify the path to the buildout configuration "
+                        "file to be used."))
+parser.add_option("-f", "--find-links",
+                  help=("Specify a URL to search for buildout releases"))
+parser.add_option("--allow-site-packages",
+                  action="store_true", default=False,
+                  help=("Let bootstrap.py use existing site packages"))
+
+
+options, args = parser.parse_args()
+
+######################################################################
+# load/install setuptools
+
+try:
+    if options.allow_site_packages:
+        import setuptools
+        import pkg_resources
+    from urllib.request import urlopen
+except ImportError:
+    from urllib2 import urlopen
+
+ez = {}
+exec(urlopen('https://bitbucket.org/pypa/setuptools/downloads/ez_setup.py'
+            ).read(), ez)
+if not options.allow_site_packages:
+    # ez_setup imports site, which adds site packages
+    # this will remove them from the path to ensure that incompatible versions 
+    # of setuptools are not in the path
+    import site
+    # inside a virtualenv, there is no 'getsitepackages'. 
+    # We can't remove these reliably
+    if hasattr(site, 'getsitepackages'):
+        for sitepackage_path in site.getsitepackages():
+            sys.path[:] = [x for x in sys.path if sitepackage_path not in x]
+
+setup_args = dict(to_dir=tmpeggs, download_delay=0)
+ez['use_setuptools'](**setup_args)
+import setuptools
+import pkg_resources
+
+# This does not (always?) update the default working set.  We will
+# do it.
+for path in sys.path:
+    if path not in pkg_resources.working_set.entries:
+        pkg_resources.working_set.add_entry(path)
+
+######################################################################
+# Install buildout
+
+ws = pkg_resources.working_set
+
+cmd = [sys.executable, '-c',
+       'from setuptools.command.easy_install import main; main()',
+       '-mZqNxd', tmpeggs]
+
+find_links = os.environ.get(
+    'bootstrap-testing-find-links',
+    options.find_links or
+    ('http://downloads.buildout.org/'
+     if options.accept_buildout_test_releases else None)
+    )
+if find_links:
+    cmd.extend(['-f', find_links])
+
+setuptools_path = ws.find(
+    pkg_resources.Requirement.parse('setuptools')).location
+
+requirement = 'zc.buildout'
+version = options.version
+if version is None and not options.accept_buildout_test_releases:
+    # Figure out the most recent final version of zc.buildout.
+    import setuptools.package_index
+    _final_parts = '*final-', '*final'
+
+    def _final_version(parsed_version):
+        for part in parsed_version:
+            if (part[:1] == '*') and (part not in _final_parts):
+                return False
+        return True
+    index = setuptools.package_index.PackageIndex(
+        search_path=[setuptools_path])
+    if find_links:
+        index.add_find_links((find_links,))
+    req = pkg_resources.Requirement.parse(requirement)
+    if index.obtain(req) is not None:
+        best = []
+        bestv = None
+        for dist in index[req.project_name]:
+            distv = dist.parsed_version
+            if _final_version(distv):
+                if bestv is None or distv > bestv:
+                    best = [dist]
+                    bestv = distv
+                elif distv == bestv:
+                    best.append(dist)
+        if best:
+            best.sort()
+            version = best[-1].version
+if version:
+    requirement = '=='.join((requirement, version))
+cmd.append(requirement)
+
+import subprocess
+if subprocess.call(cmd, env=dict(os.environ, PYTHONPATH=setuptools_path)) != 0:
+    raise Exception(
+        "Failed to execute command:\n%s",
+        repr(cmd)[1:-1])
+
+######################################################################
+# Import and run buildout
+
+ws.add_entry(tmpeggs)
+ws.require(requirement)
+import zc.buildout.buildout
+
+if not [a for a in args if '=' not in a]:
+    args.append('bootstrap')
+
+# if -c was provided, we push it back into args for buildout' main function
+if options.config_file is not None:
+    args[0:0] = ['-c', options.config_file]
+
+zc.buildout.buildout.main(args)
+shutil.rmtree(tmpeggs)
Index: /main/waeup.odoo/trunk/buildout.cfg
===================================================================
--- /main/waeup.odoo/trunk/buildout.cfg	(revision 12624)
+++ /main/waeup.odoo/trunk/buildout.cfg	(revision 12624)
@@ -0,0 +1,34 @@
+[buildout]
+parts = openerp
+versions = versions
+find-links = http://download.gna.org/pychart/
+
+[openerp]
+recipe = anybox.recipe.openerp[bzr]:server
+version = nightly 7.0 latest
+
+[versions]
+setuptools = 1.1.0
+zc.buildout = 2.2.1
+zc.recipe.eggs = 2.0.0
+anybox.recipe.openerp = 1.7.1
+babel = 0.9.6
+Pillow = 1.7.1
+pywebdav = 0.9.4.1
+PyXML = 0.8.4
+pyyaml = 3.10
+werkzeug = 0.8.3
+zsi = 2.0-rc3
+feedparser = 5.1.1
+gdata = 2.0.16
+lxml = 2.3.3
+psycopg2 = 2.4.4
+pydot = 1.0.28
+pyparsing = 1.5.6
+python-dateutil = 1.5
+python-ldap = 2.4.9
+python-openid = 2.2.5
+pytz = 2012b
+vatnumber = 1.0
+vobject = 0.8.1c
+xlwt = 0.7.3