Index: /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/reports/contract_statistics.py
===================================================================
--- /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/reports/contract_statistics.py	(revision 12659)
+++ /main/waeup.ikoba/trunk/src/waeup/ikoba/customers/reports/contract_statistics.py	(revision 12660)
@@ -17,4 +17,5 @@
 ##
 import grok
+from zope.i18n import translate
 from zope.catalog.interfaces import ICatalog
 from zope.component import queryUtility, getUtility
@@ -125,4 +126,5 @@
 
     def create_pdf(self):
+        portal_language = getUtility(IIkobaUtils).PORTAL_LANGUAGE
         creator = getUtility(IPDFCreator, name='landscape')
         table_data = tbl_data_to_table(*self.data)
@@ -133,7 +135,10 @@
         pdf_data += [
             Table(table_data, style=TABLE_STYLE, colWidths=col_widths)]
-        doc_title = 'Contracts'
+        doc_title = translate(_('Contracts'), 'waeup.ikoba',
+            target_language=portal_language)
+        footer_title = doc_title
+
         pdf = creator.create_pdf(
-            pdf_data, None, doc_title, self.author, 'Contracts'
+            pdf_data, None, doc_title, self.author, footer_title
             )
         return pdf
Index: /main/waeup.ikoba/trunk/src/waeup/ikoba/locales/waeup.ikoba.pot
===================================================================
--- /main/waeup.ikoba/trunk/src/waeup/ikoba/locales/waeup.ikoba.pot	(revision 12659)
+++ /main/waeup.ikoba/trunk/src/waeup/ikoba/locales/waeup.ikoba.pot	(revision 12660)
@@ -15,5 +15,5 @@
 msgstr ""
 "Project-Id-Version: Development/Unknown\n"
-"POT-Creation-Date: Tue Feb  3 18:11:27 2015\n"
+"POT-Creation-Date: Tue Mar  3 12:07:48 2015\n"
 "PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
@@ -121,5 +121,5 @@
 
 #: waeup/ikoba/browser/interfaces.py:173
-#: waeup/ikoba/customers/interfaces.py:201
+#: waeup/ikoba/customers/interfaces.py:202
 #: waeup/ikoba/interfaces.py:428
 #: waeup/ikoba/interfaces.py:504
@@ -132,9 +132,9 @@
 
 #: waeup/ikoba/browser/layout.py:102
-#: waeup/ikoba/customers/browser.py:387
-#: waeup/ikoba/customers/browser.py:690
-#: waeup/ikoba/customers/browser.py:973
+#: waeup/ikoba/customers/browser.py:388
+#: waeup/ikoba/customers/browser.py:691
+#: waeup/ikoba/customers/browser.py:974
 #: waeup/ikoba/customers/browser.py:1385
-#: waeup/ikoba/customers/browser.py:1416
+#: waeup/ikoba/customers/browser.py:1425
 #: waeup/ikoba/documents/browser.py:259
 msgid "Are you sure?"
@@ -201,5 +201,5 @@
 #: waeup/ikoba/browser/pages.py:125
 #: waeup/ikoba/browser/pages.py:772
-#: waeup/ikoba/customers/browser.py:207
+#: waeup/ikoba/customers/browser.py:208
 msgid "No item selected."
 msgstr ""
@@ -275,7 +275,7 @@
 
 #: waeup/ikoba/browser/pages.py:146
-#: waeup/ikoba/customers/browser.py:220
-#: waeup/ikoba/customers/browser.py:883
-#: waeup/ikoba/customers/browser.py:1253
+#: waeup/ikoba/customers/browser.py:221
+#: waeup/ikoba/customers/browser.py:884
+#: waeup/ikoba/customers/browser.py:1254
 #. Default: ""
 msgid "Successfully removed: ${a}"
@@ -291,6 +291,6 @@
 
 #: waeup/ikoba/browser/pages.py:1540
-#: waeup/ikoba/customers/browser.py:543
-#: waeup/ikoba/customers/browser.py:625
+#: waeup/ikoba/customers/browser.py:544
+#: waeup/ikoba/customers/browser.py:626
 msgid "Send login credentials to email address"
 msgstr ""
@@ -301,5 +301,5 @@
 
 #: waeup/ikoba/browser/pages.py:1564
-#: waeup/ikoba/customers/browser.py:589
+#: waeup/ikoba/customers/browser.py:590
 msgid "You have successfully requested a password for the"
 msgstr ""
@@ -311,6 +311,6 @@
 
 #: waeup/ikoba/browser/pages.py:188
-#: waeup/ikoba/customers/browser.py:84
-#: waeup/ikoba/customers/browser.py:422
+#: waeup/ikoba/customers/browser.py:85
+#: waeup/ikoba/customers/browser.py:423
 msgid "Form has been saved."
 msgstr ""
@@ -356,5 +356,5 @@
 #: waeup/ikoba/browser/pages.py:433
 #: waeup/ikoba/browser/pages.py:678
-#: waeup/ikoba/customers/browser.py:372
+#: waeup/ikoba/customers/browser.py:373
 msgid "Your message has been sent."
 msgstr ""
@@ -412,12 +412,12 @@
 #: waeup/ikoba/browser/pages.py:737
 #: waeup/ikoba/browser/pages.py:1403
-#: waeup/ikoba/customers/browser.py:400
-#: waeup/ikoba/customers/browser.py:732
-#: waeup/ikoba/customers/browser.py:774
-#: waeup/ikoba/customers/browser.py:990
-#: waeup/ikoba/customers/browser.py:1008
-#: waeup/ikoba/customers/browser.py:1402
-#: waeup/ikoba/customers/browser.py:1426
-#: waeup/ikoba/customers/browser.py:1443
+#: waeup/ikoba/customers/browser.py:401
+#: waeup/ikoba/customers/browser.py:733
+#: waeup/ikoba/customers/browser.py:775
+#: waeup/ikoba/customers/browser.py:991
+#: waeup/ikoba/customers/browser.py:1009
+#: waeup/ikoba/customers/browser.py:1411
+#: waeup/ikoba/customers/browser.py:1436
+#: waeup/ikoba/customers/browser.py:1453
 #: waeup/ikoba/documents/browser.py:255
 #: waeup/ikoba/documents/browser.py:269
@@ -438,8 +438,8 @@
 #: waeup/ikoba/browser/pages.py:1070
 #: waeup/ikoba/browser/pages.py:1175
-#: waeup/ikoba/customers/browser.py:759
-#: waeup/ikoba/customers/browser.py:790
-#: waeup/ikoba/customers/browser.py:946
-#: waeup/ikoba/customers/browser.py:1312
+#: waeup/ikoba/customers/browser.py:760
+#: waeup/ikoba/customers/browser.py:791
+#: waeup/ikoba/customers/browser.py:947
+#: waeup/ikoba/customers/browser.py:1309
 #: waeup/ikoba/documents/browser.py:106
 #: waeup/ikoba/documents/browser.py:152
@@ -455,5 +455,5 @@
 
 #: waeup/ikoba/browser/pages.py:659
-#: waeup/ikoba/customers/browser.py:353
+#: waeup/ikoba/customers/browser.py:354
 #. Default: ""
 msgid "Send message to ${a}"
@@ -491,5 +491,5 @@
 
 #: waeup/ikoba/browser/pages.py:766
-#: waeup/ikoba/customers/browser.py:176
+#: waeup/ikoba/customers/browser.py:177
 #: waeup/ikoba/products/browser.py:94
 #: waeup/ikoba/products/browser.py:101
@@ -556,5 +556,5 @@
 #: waeup/ikoba/browser/pages.py:882
 #: waeup/ikoba/browser/pages.py:1571
-#: waeup/ikoba/customers/browser.py:374
+#: waeup/ikoba/customers/browser.py:375
 msgid "An smtp server error occurred."
 msgstr ""
@@ -602,5 +602,5 @@
 msgstr ""
 
-#: waeup/ikoba/browser/reports.py:112
+#: waeup/ikoba/browser/reports.py:115
 msgid "Create report"
 msgstr ""
@@ -619,32 +619,32 @@
 msgstr ""
 
-#: waeup/ikoba/browser/templates/datacenterexportpage.pt:42
+#: waeup/ikoba/browser/templates/datacenterexportpage.pt:43
 msgid "Export Number"
 msgstr ""
 
-#: waeup/ikoba/browser/templates/datacenterexportpage.pt:43
+#: waeup/ikoba/browser/templates/datacenterexportpage.pt:44
 msgid "Exporter"
 msgstr ""
 
-#: waeup/ikoba/browser/templates/datacenterexportpage.pt:44
+#: waeup/ikoba/browser/templates/datacenterexportpage.pt:45
 msgid "Filter"
 msgstr ""
 
-#: waeup/ikoba/browser/templates/datacenterexportpage.pt:45
+#: waeup/ikoba/browser/templates/datacenterexportpage.pt:46
 #: waeup/ikoba/browser/templates/reportscontainerpage.pt:6
 msgid "Creator"
 msgstr ""
 
-#: waeup/ikoba/browser/templates/datacenterexportpage.pt:46
+#: waeup/ikoba/browser/templates/datacenterexportpage.pt:47
 #: waeup/ikoba/browser/templates/reportscontainerpage.pt:7
 msgid "Creation Date"
 msgstr ""
 
-#: waeup/ikoba/browser/templates/datacenterexportpage.pt:47
+#: waeup/ikoba/browser/templates/datacenterexportpage.pt:48
 #: waeup/ikoba/browser/templates/reportscontainerpage.pt:8
 msgid "Status"
 msgstr ""
 
-#: waeup/ikoba/browser/templates/datacenterexportpage.pt:72
+#: waeup/ikoba/browser/templates/datacenterexportpage.pt:73
 #: waeup/ikoba/browser/templates/reportscontainerpage.pt:39
 msgid "<img src=\"/static/img/actionicon_reload.png\" /> Reload"
@@ -972,40 +972,40 @@
 msgstr ""
 
-#: waeup/ikoba/customers/batching.py:142
+#: waeup/ikoba/customers/batching.py:157
 msgid "Customer record created"
 msgstr ""
 
-#: waeup/ikoba/customers/batching.py:197
+#: waeup/ikoba/customers/batching.py:212
 #. Default: ""
 msgid "State '${a}' set"
 msgstr ""
 
-#: waeup/ikoba/customers/batching.py:461
+#: waeup/ikoba/customers/batching.py:476
 msgid "Customer Sample Document Processor"
 msgstr ""
 
-#: waeup/ikoba/customers/batching.py:562
+#: waeup/ikoba/customers/batching.py:616
 msgid "Customer Sample Contract Processor"
 msgstr ""
 
-#: waeup/ikoba/customers/batching.py:60
+#: waeup/ikoba/customers/batching.py:75
 msgid "Customer Processor"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:1013
+#: waeup/ikoba/customers/browser.py:1014
 msgid "Final Submit"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:1017
-#: waeup/ikoba/customers/browser.py:1452
+#: waeup/ikoba/customers/browser.py:1018
+#: waeup/ikoba/customers/browser.py:1468
 msgid "Form has been submitted."
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:1029
+#: waeup/ikoba/customers/browser.py:1030
 #: waeup/ikoba/documents/browser.py:324
 msgid "Trigger document transition"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:106
+#: waeup/ikoba/customers/browser.py:107
 #: waeup/ikoba/customers/export.py:130
 #: waeup/ikoba/customers/viewlets.py:54
@@ -1013,13 +1013,13 @@
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:1077
+#: waeup/ikoba/customers/browser.py:1078
 msgid "Documents of"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:1085
+#: waeup/ikoba/customers/browser.py:1086
 msgid "Customer Documents"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:1091
+#: waeup/ikoba/customers/browser.py:1092
 #: waeup/ikoba/documents/browser_templates/containerpage.pt:8
 #: waeup/ikoba/documents/browser_templates/containermanagepage.pt:9
@@ -1030,6 +1030,6 @@
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:1092
-#: waeup/ikoba/customers/browser.py:1527
+#: waeup/ikoba/customers/browser.py:1093
+#: waeup/ikoba/customers/browser.py:1543
 #: waeup/ikoba/products/productoptions.py:44
 #: waeup/ikoba/documents/browser_templates/containerpage.pt:9
@@ -1042,6 +1042,6 @@
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:1093
-#: waeup/ikoba/customers/browser.py:1528
+#: waeup/ikoba/customers/browser.py:1094
+#: waeup/ikoba/customers/browser.py:1544
 #: waeup/ikoba/documents/browser_templates/containerpage.pt:10
 #: waeup/ikoba/documents/browser_templates/containermanagepage.pt:11
@@ -1051,12 +1051,12 @@
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:1094
-#: waeup/ikoba/customers/browser.py:1529
+#: waeup/ikoba/customers/browser.py:1095
+#: waeup/ikoba/customers/browser.py:1545
 #: waeup/ikoba/customers/browser_templates/containerpage.pt:33
 msgid "State"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:1095
-#: waeup/ikoba/customers/browser.py:1530
+#: waeup/ikoba/customers/browser.py:1096
+#: waeup/ikoba/customers/browser.py:1546
 #: waeup/ikoba/customers/browser_templates/contractsmanagepage.pt:12
 #: waeup/ikoba/customers/browser_templates/documentsmanagepage.pt:12
@@ -1064,244 +1064,265 @@
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:1181
+#: waeup/ikoba/customers/browser.py:1182
+#: waeup/ikoba/customers/reports/contract_statistics.py:137
 #: waeup/ikoba/customers/viewlets.py:160
 msgid "Contracts"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:1226
+#: waeup/ikoba/customers/browser.py:1227
 #. Default: ""
 msgid "${a}: Contracts"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:1229
-#: waeup/ikoba/customers/browser.py:1270
-#: waeup/ikoba/customers/browser.py:1295
+#: waeup/ikoba/customers/browser.py:1230
+#: waeup/ikoba/customers/browser.py:1271
+#: waeup/ikoba/customers/browser.py:1293
 msgid "Add contract"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:1234
+#: waeup/ikoba/customers/browser.py:1235
 msgid "Remove selected contracts"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:1240
+#: waeup/ikoba/customers/browser.py:1241
 msgid "No contract selected."
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:132
+#: waeup/ikoba/customers/browser.py:1322
+msgid "Select product"
+msgstr ""
+
+#: waeup/ikoba/customers/browser.py:133
 msgid "Find customers"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:1325
-msgid "Select product"
-msgstr ""
-
-#: waeup/ikoba/customers/browser.py:133
+#: waeup/ikoba/customers/browser.py:1333
+msgid "Save and proceed"
+msgstr ""
+
+#: waeup/ikoba/customers/browser.py:134
+#: waeup/ikoba/customers/browser.py:176
+msgid "Find customer(s)"
+msgstr ""
+
+#: waeup/ikoba/customers/browser.py:1458
+msgid "Apply now (final submit)"
+msgstr ""
+
+#: waeup/ikoba/customers/browser.py:1462
+msgid "Please read the terms and conditions and confirm your acceptance of these by ticking the confirmation box."
+msgstr ""
+
+#: waeup/ikoba/customers/browser.py:1480
+msgid "Trigger contract transition"
+msgstr ""
+
+#: waeup/ikoba/customers/browser.py:151
+#: waeup/ikoba/customers/browser.py:193
+msgid "Empty search string"
+msgstr ""
+
+#: waeup/ikoba/customers/browser.py:1528
+msgid "Contracts of"
+msgstr ""
+
+#: waeup/ikoba/customers/browser.py:1536
+msgid "Customer Contracts"
+msgstr ""
+
+#: waeup/ikoba/customers/browser.py:157
+#: waeup/ikoba/customers/browser.py:199
+msgid "Only year dates allowed (e.g. 2011)."
+msgstr ""
+
+#: waeup/ikoba/customers/browser.py:1609
+msgid "Customer Signature"
+msgstr ""
+
+#: waeup/ikoba/customers/browser.py:1610
+msgid "Company Officer Signature"
+msgstr ""
+
+#: waeup/ikoba/customers/browser.py:1614
+msgid "Date, Customer Signature"
+msgstr ""
+
+#: waeup/ikoba/customers/browser.py:1615
+msgid "Date, Company Officer Signature"
+msgstr ""
+
+#: waeup/ikoba/customers/browser.py:163
+#: waeup/ikoba/customers/browser.py:206
+#: waeup/ikoba/customers/browser.py:564
+#: waeup/ikoba/customers/browser.py:576
+msgid "No customer found."
+msgstr ""
+
 #: waeup/ikoba/customers/browser.py:175
-msgid "Find customer(s)"
-msgstr ""
-
-#: waeup/ikoba/customers/browser.py:1336
-msgid "Save and proceed"
-msgstr ""
-
-#: waeup/ikoba/customers/browser.py:1448
-msgid "Apply now (final submit)"
-msgstr ""
-
-#: waeup/ikoba/customers/browser.py:1464
-msgid "Trigger contract transition"
-msgstr ""
-
-#: waeup/ikoba/customers/browser.py:150
-#: waeup/ikoba/customers/browser.py:192
-msgid "Empty search string"
-msgstr ""
-
-#: waeup/ikoba/customers/browser.py:1512
-msgid "Contracts of"
-msgstr ""
-
-#: waeup/ikoba/customers/browser.py:1520
-msgid "Customer Contracts"
-msgstr ""
-
-#: waeup/ikoba/customers/browser.py:156
-#: waeup/ikoba/customers/browser.py:198
-msgid "Only year dates allowed (e.g. 2011)."
-msgstr ""
-
-#: waeup/ikoba/customers/browser.py:162
-#: waeup/ikoba/customers/browser.py:205
-#: waeup/ikoba/customers/browser.py:563
-#: waeup/ikoba/customers/browser.py:575
-msgid "No customer found."
-msgstr ""
-
-#: waeup/ikoba/customers/browser.py:174
 #: waeup/ikoba/customers/viewlets.py:180
 msgid "Manage customer section"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:233
+#: waeup/ikoba/customers/browser.py:234
 #: waeup/ikoba/customers/viewlets.py:188
 msgid "Add customer"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:236
+#: waeup/ikoba/customers/browser.py:237
 msgid "Create customer record"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:241
+#: waeup/ikoba/customers/browser.py:242
 msgid "Customer created."
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:256
+#: waeup/ikoba/customers/browser.py:257
 #. Default: ""
 msgid "Set temporary password for ${a}"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:279
+#: waeup/ikoba/customers/browser.py:280
 msgid "Login now"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:283
+#: waeup/ikoba/customers/browser.py:284
 #. Default: ""
 msgid "Login as ${a}"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:289
+#: waeup/ikoba/customers/browser.py:290
 msgid "You successfully logged in as customer."
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:312
+#: waeup/ikoba/customers/browser.py:313
 #. Default: ""
 msgid "${a}: Base Data (account deactivated)"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:314
+#: waeup/ikoba/customers/browser.py:315
 #. Default: ""
 msgid "${a}: Base Data"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:320
+#: waeup/ikoba/customers/browser.py:321
 msgid "set"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:321
+#: waeup/ikoba/customers/browser.py:322
 msgid "unset"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:385
+#: waeup/ikoba/customers/browser.py:386
 msgid "Manage base data"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:435
+#: waeup/ikoba/customers/browser.py:436
 msgid "Trigger registration transition"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:447
-#: waeup/ikoba/customers/browser.py:1044
-#: waeup/ikoba/customers/browser.py:1479
+#: waeup/ikoba/customers/browser.py:448
+#: waeup/ikoba/customers/browser.py:1045
+#: waeup/ikoba/customers/browser.py:1495
 #: waeup/ikoba/documents/browser.py:339
 msgid "No transition"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:450
-#: waeup/ikoba/customers/browser.py:1047
-#: waeup/ikoba/customers/browser.py:1482
+#: waeup/ikoba/customers/browser.py:451
+#: waeup/ikoba/customers/browser.py:1048
+#: waeup/ikoba/customers/browser.py:1498
 msgid "Apply"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:457
-#: waeup/ikoba/customers/browser.py:1055
-#: waeup/ikoba/customers/browser.py:1490
+#: waeup/ikoba/customers/browser.py:458
+#: waeup/ikoba/customers/browser.py:1056
+#: waeup/ikoba/customers/browser.py:1506
 #: waeup/ikoba/documents/browser.py:350
 msgid "Transition '%s' executed."
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:474
+#: waeup/ikoba/customers/browser.py:475
 msgid "Customer account has been activated."
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:494
+#: waeup/ikoba/customers/browser.py:495
 msgid "Customer account has been deactivated."
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:513
+#: waeup/ikoba/customers/browser.py:514
 #. Default: ""
 msgid "${a}: History"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:523
+#: waeup/ikoba/customers/browser.py:524
 msgid "Request password for first-time login"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:557
+#: waeup/ikoba/customers/browser.py:558
 msgid "An error occurred."
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:566
+#: waeup/ikoba/customers/browser.py:567
 msgid "Your password has already been set and used. Please proceed to the login page."
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:610
+#: waeup/ikoba/customers/browser.py:611
 msgid "Create customer account"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:64
+#: waeup/ikoba/customers/browser.py:649
+msgid "You have successfully created a customer account for the"
+msgstr ""
+
+#: waeup/ikoba/customers/browser.py:65
 msgid "You can not edit some data after final submission. You really want to submit?"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:648
-msgid "You have successfully created a customer account for the"
-msgstr ""
-
-#: waeup/ikoba/customers/browser.py:669
+#: waeup/ikoba/customers/browser.py:670
 msgid "Your request was successful."
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:67
+#: waeup/ikoba/customers/browser.py:68
 msgid "You can not edit your document after final submission. You really want to submit?"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:688
+#: waeup/ikoba/customers/browser.py:689
 #: waeup/ikoba/customers/viewlets.py:303
 msgid "Upload files"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:70
+#: waeup/ikoba/customers/browser.py:71
 msgid "You can not edit your contract after final submission. You really want to submit?"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:721
+#: waeup/ikoba/customers/browser.py:722
 msgid "Edit base data and request registration"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:722
+#: waeup/ikoba/customers/browser.py:723
 msgid "Edit base data"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:741
+#: waeup/ikoba/customers/browser.py:742
 msgid "Passport picture is missing."
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:746
+#: waeup/ikoba/customers/browser.py:747
 msgid "Save and request registration now"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:755
+#: waeup/ikoba/customers/browser.py:756
 msgid "Registration form has been submitted."
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:771
+#: waeup/ikoba/customers/browser.py:772
 #: waeup/ikoba/customers/viewlets.py:293
 msgid "Change password"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:785
+#: waeup/ikoba/customers/browser.py:786
 msgid "Password changed."
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:816
+#: waeup/ikoba/customers/browser.py:817
 #: waeup/ikoba/customers/viewlets.py:166
 #: waeup/ikoba/documents/browser.py:62
@@ -1312,12 +1333,12 @@
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:856
+#: waeup/ikoba/customers/browser.py:857
 #. Default: ""
 msgid "${a}: Documents"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:859
-#: waeup/ikoba/customers/browser.py:900
-#: waeup/ikoba/customers/browser.py:924
+#: waeup/ikoba/customers/browser.py:860
+#: waeup/ikoba/customers/browser.py:901
+#: waeup/ikoba/customers/browser.py:925
 #: waeup/ikoba/documents/browser.py:96
 #: waeup/ikoba/documents/browser.py:119
@@ -1326,15 +1347,15 @@
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:864
+#: waeup/ikoba/customers/browser.py:865
 #: waeup/ikoba/documents/browser.py:101
 msgid "Remove selected documents"
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:870
+#: waeup/ikoba/customers/browser.py:871
 msgid "No document selected."
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:935
-#: waeup/ikoba/customers/browser.py:1306
+#: waeup/ikoba/customers/browser.py:936
+#: waeup/ikoba/customers/browser.py:1303
 #: waeup/ikoba/documents/browser.py:144
 #. Default: ""
@@ -1342,5 +1363,5 @@
 msgstr ""
 
-#: waeup/ikoba/customers/browser.py:94
+#: waeup/ikoba/customers/browser.py:95
 msgid "The requested form is locked (read-only)."
 msgstr ""
@@ -1382,6 +1403,14 @@
 msgstr ""
 
+#: waeup/ikoba/customers/browser_templates/contracteditpage.pt:20
+msgid "I confirm that I have read, understood and accepted the Terms & Conditions."
+msgstr ""
+
 #: waeup/ikoba/customers/browser_templates/contractpage.pt:20
 msgid "Contract Type:"
+msgstr ""
+
+#: waeup/ikoba/customers/browser_templates/contractpage.pt:29
+msgid "Validity Period:"
 msgstr ""
 
@@ -1443,10 +1472,10 @@
 msgstr ""
 
-#: waeup/ikoba/customers/contracts.py:147
+#: waeup/ikoba/customers/contracts.py:146
 #: waeup/ikoba/customers/documents.py:162
 msgid "Customer has not yet been approved."
 msgstr ""
 
-#: waeup/ikoba/customers/contracts.py:153
+#: waeup/ikoba/customers/contracts.py:152
 msgid "Attached documents must be verified first."
 msgstr ""
@@ -1493,36 +1522,36 @@
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:102
-#: waeup/ikoba/customers/interfaces.py:196
-#: waeup/ikoba/customers/interfaces.py:214
+#: waeup/ikoba/customers/interfaces.py:103
+#: waeup/ikoba/customers/interfaces.py:197
+#: waeup/ikoba/customers/interfaces.py:215
 msgid "First Name"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:107
-#: waeup/ikoba/customers/interfaces.py:219
+#: waeup/ikoba/customers/interfaces.py:108
+#: waeup/ikoba/customers/interfaces.py:220
 msgid "Middle Name"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:112
-#: waeup/ikoba/customers/interfaces.py:224
+#: waeup/ikoba/customers/interfaces.py:113
+#: waeup/ikoba/customers/interfaces.py:225
 msgid "Last Name (Surname)"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:117
+#: waeup/ikoba/customers/interfaces.py:118
 msgid "Sex"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:123
-#: waeup/ikoba/customers/interfaces.py:162
-#: waeup/ikoba/customers/interfaces.py:191
+#: waeup/ikoba/customers/interfaces.py:124
+#: waeup/ikoba/customers/interfaces.py:163
+#: waeup/ikoba/customers/interfaces.py:192
 msgid "Registration Number"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:130
-#: waeup/ikoba/customers/interfaces.py:229
+#: waeup/ikoba/customers/interfaces.py:131
+#: waeup/ikoba/customers/interfaces.py:230
 msgid "Email"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:137
+#: waeup/ikoba/customers/interfaces.py:138
 #: waeup/ikoba/interfaces.py:433
 #: waeup/ikoba/interfaces.py:511
@@ -1530,48 +1559,60 @@
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:253
+#: waeup/ikoba/customers/interfaces.py:254
 #: waeup/ikoba/documents/interfaces.py:52
 msgid "Document Id"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:304
+#: waeup/ikoba/customers/interfaces.py:307
 msgid "Contract Id"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:310
-#: waeup/ikoba/customers/interfaces.py:333
+#: waeup/ikoba/customers/interfaces.py:313
+#: waeup/ikoba/customers/interfaces.py:336
 msgid "Product"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:316
-#: waeup/ikoba/customers/interfaces.py:366
+#: waeup/ikoba/customers/interfaces.py:319
 #: waeup/ikoba/products/interfaces.py:73
 msgid "Options/Fees"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:345
-#: waeup/ikoba/customers/interfaces.py:380
+#: waeup/ikoba/customers/interfaces.py:348
+#: waeup/ikoba/customers/interfaces.py:391
 msgid "Document"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:356
+#: waeup/ikoba/customers/interfaces.py:359
 msgid "Comment"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:83
+#: waeup/ikoba/customers/interfaces.py:84
 msgid "Account suspended"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:89
+#: waeup/ikoba/customers/interfaces.py:90
 msgid "Reasons for Deactivation"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:91
+#: waeup/ikoba/customers/interfaces.py:92
 msgid "This message will be shown if and only if deactivated customers try to login."
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:97
+#: waeup/ikoba/customers/interfaces.py:98
 #: waeup/ikoba/customers/browser_templates/containerpage.pt:31
 msgid "Customer Id"
+msgstr ""
+
+#: waeup/ikoba/customers/reports/contract_statistics.py:149
+#: waeup/ikoba/customers/reports/contract_statistics.py:226
+msgid "Contract Statistics"
+msgstr ""
+
+#: waeup/ikoba/customers/reports/contract_statistics.py:172
+msgid "Create contract statistics report"
+msgstr ""
+
+#: waeup/ikoba/customers/reports/contract_statistics.py:188
+msgid "New report is being created in background"
 msgstr ""
 
@@ -1669,7 +1710,12 @@
 msgstr ""
 
-#: waeup/ikoba/customers/utils.py:425
+#: waeup/ikoba/customers/utils.py:414
+msgid "Validity Period"
+msgstr ""
+
+#: waeup/ikoba/customers/utils.py:432
 #: waeup/ikoba/products/interfaces.py:95
-#: waeup/ikoba/customers/browser_templates/contractpage.pt:32
+#: waeup/ikoba/customers/browser_templates/contractpage.pt:46
+#: waeup/ikoba/customers/browser_templates/contracteditpage.pt:15
 msgid "Terms and Conditions"
 msgstr ""
@@ -4938,4 +4984,8 @@
 msgstr ""
 
+#: waeup/ikoba/utils/helpers.py:868
+msgid "indefinite"
+msgstr ""
+
 #: waeup/ikoba/utils/utils.py:111
 msgid "no contract"