Index: /main/waeup.fceokene/trunk/src/waeup/fceokene/interswitch/browser.py
===================================================================
--- /main/waeup.fceokene/trunk/src/waeup/fceokene/interswitch/browser.py	(revision 12660)
+++ /main/waeup.fceokene/trunk/src/waeup/fceokene/interswitch/browser.py	(revision 12661)
@@ -81,15 +81,15 @@
             self.pay_item_id = '8302'
             if student.current_mode in ('nce_sw','prence',):
-                xmldict['institution_acct'] = "1012044194"
+                xmldict['institution_acct'] = "1013780934"
                 xmldict['institution_bank_id'] = '117'
             elif student.current_mode in ('nce_ft',) and \
                 student['studycourse'].current_verdict == 'O':
-                xmldict['institution_acct'] = "1012044015"
+                xmldict['institution_acct'] = "1013780934"
                 xmldict['institution_bank_id'] = '117'
             elif student.current_mode in ('nce_ft',):
-                xmldict['institution_acct'] = "1012044015"
+                xmldict['institution_acct'] = "1013780934"
                 xmldict['institution_bank_id'] = '117'
             elif student.current_mode in ('pd_ft',):
-                xmldict['institution_acct'] = "1012415659"
+                xmldict['institution_acct'] = "1013780934"
                 xmldict['institution_bank_id'] = '117'
             #undergraduate schoolfee added
@@ -107,5 +107,5 @@
             xmldict['institution_amt'] = 100 * (
                 self.context.amount_auth - GATEWAY_AMT)
-            xmldict['institution_acct'] = "1012044132"
+            xmldict['institution_acct'] = "1013780934"
             xmldict['institution_bank_id'] = '117'
         elif self.context.p_category == 'clearance':
@@ -123,5 +123,5 @@
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
 <item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-<item_detail item_id="2" item_name="FCEOkene Split" item_amt="%(fceokene_split)d" bank_id="117" acct_num="1012044039" />
+<item_detail item_id="2" item_name="FCEOkene Split" item_amt="%(fceokene_split)d" bank_id="117" acct_num="1013780934" />
 <item_detail item_id="3" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
 </item_details>
@@ -168,5 +168,5 @@
             xmldict['institution_bank_id'] = '8'
         else:
-            xmldict['institution_acct'] = '1012445289'
+            xmldict['institution_acct'] = '1013780934'
             xmldict['institution_bank_id'] = '117'
         xmldict['institution_amt'] = 100 * (self.context.amount_auth -
Index: /main/waeup.fceokene/trunk/src/waeup/fceokene/interswitch/tests.py
===================================================================
--- /main/waeup.fceokene/trunk/src/waeup/fceokene/interswitch/tests.py	(revision 12660)
+++ /main/waeup.fceokene/trunk/src/waeup/fceokene/interswitch/tests.py	(revision 12661)
@@ -97,8 +97,8 @@
             in self.browser.contents)
         self.assertTrue(
-            'item_name="School Fee" item_amt="1182500" bank_id="117" acct_num="1012044015"'
-            in self.browser.contents)
-        self.assertTrue(
-            'item_name="FCEOkene Split" item_amt="140000" bank_id="117" acct_num="1012044039"'
+            'item_name="School Fee" item_amt="1182500" bank_id="117" acct_num="1013780934"'
+            in self.browser.contents)
+        self.assertTrue(
+            'item_name="FCEOkene Split" item_amt="140000" bank_id="117" acct_num="1013780934"'
             in self.browser.contents)
         self.assertTrue(
@@ -121,8 +121,8 @@
             in self.browser.contents)
         self.assertTrue(
-            'item_name="NCE Third Semester Fee" item_amt="476300" bank_id="117" acct_num="1012044015"'
-            in self.browser.contents)
-        self.assertTrue(
-            'item_name="FCEOkene Split" item_amt="140000" bank_id="117" acct_num="1012044039"'
+            'item_name="NCE Third Semester Fee" item_amt="476300" bank_id="117" acct_num="1013780934"'
+            in self.browser.contents)
+        self.assertTrue(
+            'item_name="FCEOkene Split" item_amt="140000" bank_id="117" acct_num="1013780934"'
             in self.browser.contents)
         self.assertTrue(
@@ -189,5 +189,5 @@
             in self.browser.contents)
         self.assertTrue(
-            'item_name="Hostel Maintenance Fee" item_amt="400000" bank_id="117" acct_num="1012044132"'
+            'item_name="Hostel Maintenance Fee" item_amt="400000" bank_id="117" acct_num="1013780934"'
             in self.browser.contents)
         # BT does nor charge a fee for maintenance fee
@@ -374,5 +374,5 @@
         self.assertTrue(
             '<item_detail item_id="1" item_name="application"'
-            ' item_amt="35000" bank_id="117" acct_num="1012445289" />'
+            ' item_amt="35000" bank_id="117" acct_num="1013780934" />'
             in self.browser.contents)
 